import os, sys, platform
import userinterface
try:
	import json as json
except ImportError:
	try:
		import simplejson as json
	except: pass



##########################
## FIRST TIME RUN CHECK ##
##########################
config = {}

def configPathTest(element):
	global config
	config['bin_path'][element] = config['bin_path'][element].rstrip()
	if not os.path.exists(config['bin_path'][element]):
		print "\n\nSORRY, this path is not valid!\n%s\n"%config['bin_path'][element]
		sys.exit(1)
	if os.path.isdir(config['bin_path'][element]):
		print "\n\nSORRY, this path is a directory, not a binary!\n%s\n"%config['bin_path'][element]
		sys.exit(1)

def runBinaryConfig(configFileLoc, version):
	global config
	config['audioguide_version'] = version
	config['bin_path'] = {}
	userinterface.lady_print("\n\nHello.  Welcome to Audioguide.  To configure Audioguide, I'll need some information about the full paths of various binaries on your machine.  On Osx, you can just drag the requested file right into the terminal prompt and press enter...")
	
	config['bin_path']['ircamd'] = raw_input("\n\n\n  Enter the path of the ircamdescriptor binary\n(e.g. /Users/ben/bin/ircamdescriptor_2_8_6/ircamdescriptor-2.8.6, NOT the directory) > ")
	configPathTest('ircamd')
	config['bin_path']['pm2'] = raw_input("\n\n  Enter the path of pm2 binary\n(e.g. /Applications/AudioSculpt3.0b7/Kernels/pm2) > ")
	configPathTest('pm2')
	config['bin_path']['supervp'] = raw_input("\n\n  Enter the path of supervp binary\n(e.g. /Applications/AudioSculpt3.0b7/Kernels/supervp) > ")
	configPathTest('supervp')

	jh = open(configFileLoc, 'w')
	json.dump(config, jh)
	jh.close()
	
	userinterface.lady_print("\n\nAll done!  Et maintenant tu peux aller te faire enculer... a sec... avec des gravillons!")


def get(version, agPath):
	global config
	configFileLoc = os.path.join(agPath, 'audioguide_config.json')
	if not os.path.exists(configFileLoc):
		runBinaryConfig(configFileLoc, version)
	else:
		jh = open(configFileLoc, 'r')
		config = json.load(jh)
		jh.close()
		for name, path in config['bin_path'].iteritems():
			if not os.path.exists(path):
				os.remove(configFileLoc)
				runBinaryConfig(configFileLoc)
				break

	# locate directory of precompiled libraries. depends on:
	#	python version
	#  system -- Darwin, Linux, etc.
	#  python bit rate (32 or 64)
	if sys.maxsize > 2**32: bits = 64
	else: bits = 32
	systemName = platform.system().lower()
	dirName = 'pylib%i.%i-%s-%i'%(sys.version_info[0], sys.version_info[1], systemName, bits)
	config['py_compiled_lib_dir'] = os.path.join(os.path.dirname(__file__), dirName)
	return config

