#!/usr/bin/env python2.5
import os, sys
import mu

def makeNgenTxt(agScorePath, start=0, dur=1, reverb=96):
	print agScorePath, start, dur, reverb
	tmp = open(agScorePath, 'r')
	lines = tmp.readlines()
	tmp.close
	target = lines[0][1:].replace('\n','').split()
	tgtShortName = os.path.split(target[0])[1]
	targetStr = ' '.join((tgtShortName, 'from', target[1], '->', target[3]))
	scoreInt = os.path.splitext(os.path.split(agScorePath)[1])[0]
	ngenString = '''rs(1) ; '''+targetStr+'''
i50 = 64   '''+str(start)+'''   -1
{ 
	p2 1
	p3 '''+str(float(dur)+400)+'''
	p4 100 ; amp scaling
;	SOURCE INFO
	p5 33 ; AG file read
	p6 '''+str(scoreInt)+''' ; fileInt
	p7 0 ; start in score, reads for p3
	p8 1 ; tempo scale start
	p9 1 ; tempo scale end
	p10 1 ; tempo scale slope
	p11 1 ; 0=none, 1=remove start offset
	p12 1 ; compress amps: 1=none, 0.5=compress, 2=expand
	p13 0 ; attack % or second(400+)
	p14 0 ; decay % or second(400+)
	p15 -0 ; envelope attenuation dB
	p16 0 ; stretch according to temposcale; 0=no stretch
	p17 0 ; semitone trans add
	p18 0 ; remove space -- 1=peak amp, 2=effdur, 1.5=half way
	p19 0 p20 0 p21 0 p22 0 p23 0 p24 0 ; null
;	PROCESSING I
	p25 0 p26 0 p27 0 p28 0 p29 0 p30 0 p31 0 p32 0 p33 0 p34 0 ; null
;	PROCESSING II
	p35 0 p36 0 p37 0 p38 0 p39 0 p40 0 p41 0 p42 0 p43 0 p44 0 ; null
;	ENVELOPE INFO -- MASK AUDIOGUIDE EVENT AMPLITUDES!
	p45 0 p46 0 p47 0 p48 0 p49 0 p50 0 p51 0 p52 0 p53 0 p54 0 ; null
;	SPATIALIZATION INFO
	p55 11.1 ; AudioGuide Amplitude-based DISPERSION
	p56 0 ; center degree
	p57 0 ; amplitude disperse maximum
	p58 1 ; dispersion width exponent (below 1 = narrower)
	p59 3 ; target segment spatial partition
	p60 50 ; segment node dispersion degrees
	p61 15 ; spread
	p62 '''+str(reverb)+''' ; reverb
	p63 0 p64 0 ; null\n}\n\n'''
	return ngenString, tgtShortName


if __name__=="__main__":
	path = '/Users/ben/composition/quintet/includes/agScores'
	disPath = '/Users/ben/composition/quintet/ag/iterate'

	from optparse import OptionParser
	parser = OptionParser()
	parser.add_option("-u", "--ungrab", action="store_false", dest="GRAB", default=True)
	opts, args = parser.parse_args()	
	if opts.GRAB:
		if len(args) == 0:
			score = '/Users/ben/Documents/audioGuide/output/csoundScore.txt'
			config = '/Users/ben/Documents/audioGuide/output/parsedOptions.py'
		else: # a dissimilairty folder...
			score = os.path.join(disPath, args[0], 'score', args[1]+'.txt')
			config = os.path.join(disPath, args[0], 'config', args[1]+'.py')
			if not os.path.exists(score):
				print "Cannot find file", dir
				sys.exit()
			
		start = 0
		dur = 1
		for i in xrange(1, sys.maxint):
			uni_fn = os.path.join('%d%s' % (i, '.txt'))
			if not os.path.exists(path+"/sco/"+uni_fn):
				fileInt = str(i)
				break
	
		configDest = os.path.join(path, 'config', fileInt+'.py')
		scoreDest = os.path.join(path, 'sco', fileInt+'.txt')
		mu.executeCommand('cp '+score+' '+scoreDest)
		mu.executeCommand('cp '+config+' '+configDest)
		outputShort, tgtShortName = makeNgenTxt(scoreDest, start=start, dur=dur)
	
		print "\n\t-> grabbed audioguide number", i, "generated from", tgtShortName, "\n"
		mu.copyToClipboard(outputShort)
	else:
		files = os.listdir('/Users/ben/composition/quintet/includes/agScores/sco')
		print files

		print "\n\t-> ungrabbing audioguide number", 1, "\n"
