#!/usr/bin/env python2.7
import sys, os, platform

#######################
## find options file ##
#######################
if len(sys.argv) == 1:
	print('\nPlease specify an options file as the first argument\n')
	sys.exit(1)
opspath = os.path.realpath(sys.argv[1])
if not os.path.exists(opspath):
	print('\nCouldn\'t find an options called "%s"\n'%sys.argv[1])
	sys.exit(1)

####################
## run audioguide ##
####################
try:
	import audioguide
	agPrintTitle = os.path.split(opspath)[1]
	ag = audioguide.main(os.path.dirname(os.path.realpath(__file__)), 'defaults.py', loadOptionsFromFile=opspath, printName=agPrintTitle)
	ag.init()
	ag.loadTarget()
	ag.loadDatabase()
	ag.normalizeData()
	ag.concatenate()
	madeFile = ag.render()
	if madeFile:
		# if rendered a file, play it at the command line
		commandLinePlayers = {'Darwin': 'afplay', 'Linux': 'aplay', 'Windows': 'mplay32 \play'}
		os.system('%s "%s"'%(commandLinePlayers[platform.system()], audioguide.outputFiles.csoundFileName)) 
except KeyboardInterrupt:
	# die if user does a control-D
	print('\n\n')
	sys.exit(1)